#include "cparser.h"

#include <stdio.h>
#include <stdlib.h>

void dump_symbol(const char* name, const Type* type) {
    char* s = chop_type2str(type);
    printf("%s %s\n", s, name);
    free(s);
}

void dump_macro(const char* name, const char* value) {
    printf("%s %s\n", name, value);
}

int main(int argc, char* argv[]) {
    if (argc == 1) return 1;

    chop_init();
    chop_cparse(argv[1]);

    puts("Symbols:");
    chop_iter_symbols(&dump_symbol);
    puts("Macros:");
    chop_iter_macros(&dump_macro);

    chop_quit();

    return 0;
}
