require 'dl/import'
require 'dl/struct'
require 'chop.so'

module Chop
  include DL::Importable

  def include(s)
    if s.class == String
      c_include(s)
    else
      super(s)
    end
  end

  def method_missing(sym, *args)
    name = sym.to_s
    if ra = Chop.get_symbol(name)
      import(name, ra[0], ra[1..-1])
      send(sym, *args)
    else
      super(sym, *args)
    end
  end

  def const_missing(sym)
    name = sym.to_s
    s = Chop.get_struct(name)
    if (!s && name =~ /^[A-Z]/)
      s = Chop.get_struct($&.downcase+$')
    end

    if s
      struct(s)
    else
      super(sym)
    end
  end
end

