require 'chop'

module LIBC
  extend Chop

  dlload 'libc.so.6'
  include 'stdio.h'
  include 'stdlib.h'
  include 'string.h'
  include 'ctype.h'
  include 'time.h'
  include 'sys/time.h'

  def my_compare(ptr1, ptr2)
    ptr1.ptr.to_s <=> ptr2.ptr.to_s
  end
  COMPARE = callback("int my_compare(char**, char**)")
end

p LIBC.atoi("10")

p LIBC.isdigit(?1)

p LIBC.isdigit(?a)

p LIBC.strcat("a", "b")

ary = ["a","c","b"]
ptr = ary.to_ptr
LIBC.qsort(ptr, ary.length, DL.sizeof('P'), LIBC::COMPARE)
p ptr.to_a('S', ary.length)

tv = LIBC::Timeval.malloc
tz = LIBC::Timezone.malloc
LIBC.gettimeofday(tv, tz)

p Time.at(tv.tv_sec)

p LIBC.random
